<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { UseLocalizedVideoSubtitles } from '~/mixins';

interface Video {
  header: string;
  description: string;
  button?: {
    text: string;
    href: string;
    gaName: string;
  };
  url: string;
}

export default Vue.extend({
  mixins: [UseLocalizedVideoSubtitles],
  props: {
    videos: { type: Array as PropType<Video[]>, required: true },
  },
});
</script>

<template>
  <div class="videos">
    <div v-for="video in videos" :key="video.header" class="video">
      <div class="text">
        <SlpTypography variant="heading3-bold" tag="h3">{{
          video.header
        }}</SlpTypography>
        <SlpTypography variant="body1" tag="p">{{
          video.description
        }}</SlpTypography>
        <SlpButton
          v-if="video.button"
          :href="video.button.href"
          class="cta"
          :data-ga-name="video.button.gaName"
          data-ga-location="body"
        >
          {{ video.button.text }}
          <SlpIcon name="chevron-right" variant="product" class="slp-ml-8" />
        </SlpButton>
      </div>
      <div class="video-player">
        <iframe
          :src="createVideoSource(video.url)"
          title="video player"
          frameborder="0"
          allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.videos {
  display: flex;
  flex-direction: column;
  gap: 80px;
  margin: 192px 0;
  .video {
    display: flex;
    flex-direction: column;
    gap: 16px;
    @media (min-width: $breakpoint-lg) {
      flex-direction: row;
    }
    .text {
      display: flex;
      flex-direction: column;
      gap: 12px;
      .cta {
        width: fit-content;
      }
    }
    .video-player {
      flex-basis: 60%;
      display: flex;
      align-items: center;
      justify-content: center;
      iframe {
        @media (min-width: $breakpoint-lg) {
          min-width: 735px;
          min-height: 432px;
        }
      }
    }
  }
}
</style>
